import 'dart:convert';

import 'package:json_annotation/json_annotation.dart';
import 'package:libaqueous/src/api/events/model/unsigned_data.dart';

part 'event.g.dart';

@JsonSerializable()
class Event {
  @JsonKey(name: "type")
  String type;

  @JsonKey(name: "event_id")
  String eventID;

  @JsonKey(name: "content")
  Map<String, dynamic> content;

  @JsonKey(name: "prev_content")
  Map<String, dynamic> refreshToken;

  @JsonKey(name: "origin_server_ts")
  int originServerTs;

  @JsonKey(name: "sender")
  String sender;

  @JsonKey(name: "state_key")
  String stateKey;

  @JsonKey(name: "room_id")
  String roomID;

  @JsonKey(name: "unsigned")
  UnsignedData unsignedData;

  @JsonKey(name: "redacts")
  String redacts;

  String toString() => jsonEncode(toJson());

  static const fromJson = _$EventFromJson;

  Map<String, dynamic> toJson() => _$EventToJson(this);
}
