import 'package:libaqueous/src/client/room/room.dart';
import 'package:libaqueous/src/client/room/room_account_data.dart';
import 'package:libaqueous/src/client/room/room_state.dart';
import 'package:libaqueous/src/client/room/room_timeline.dart';
import 'package:libaqueous/src/client/user/user.dart';
import 'package:libaqueous/src/client/user/user_state.dart';

class Store {
  Set<String> _roomIDs;
  Set<String> _userIDs;

  Map<String, RoomState> _roomStates;
  Map<String, RoomAccountData> _roomAccountData;
  Map<String, RoomTimeline> _roomTimeline;

  Map<String, UserState> _userStates;

  String _syncToken;

  Future<void> open() async {
    _roomIDs = Set();
    _roomStates = {};
    _roomAccountData = {};
    _roomTimeline = {};

    _userIDs = Set();
    _userStates = {};
  }

  Future<void> close() async {}

  Future<void> commit() async {}

  Future<void> clear() async {}

  Future<String> syncToken() async => _syncToken;

  Future<void> setSyncToken(String token) async {
    _syncToken = token;
  }

  Future<List<String>> roomIDs() async {
    return _roomIDs.toList();
  }

  Future<RoomState> roomState(String id) async {
    return _roomStates[id];
  }

  Future<RoomAccountData> roomAccountData(String id) async {
    return _roomAccountData[id];
  }

  Future<RoomTimeline> roomTimeline(String id) async {
    return _roomTimeline[id];
  }

  Future<void> storeRoom(Room room) async {
    final id = room.id;

    if (!_roomIDs.contains(id)) {
      _roomIDs.add(id);
    }

    _roomAccountData[id] = room.accountData;
    _roomStates[id] = room.state;
  }

  Future<List<String>> userIDs() async {
    return _userIDs.toList();
  }

  Future<UserState> userState(String id) async {
    return _userStates[id];
  }

  Future<void> storeUser(User user) async {
    final id = user.id;

    if (!_userIDs.contains(id)) {
      _userIDs.add(id);
    }

    _userStates[id] = user.state;
  }
}
